models/ContactForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * ContactForm is the model behind the contact form.
 */
class ContactForm extends Model
{
    public $name;
    public $email;
    public $subject;
    public $body;
    public $verifyCode;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // name, email, subject and body are required
            [['name', 'email', 'subject', 'body'], 'required'],
            // email has to be a valid email address
            ['email', 'email'],
            // verifyCode needs to be entered correctly
            ['verifyCode', 'captcha'],
        ];
    }

    /**
     * @return array customized attribute labels
     */
    public function attributeLabels()
    {
        return [
            'verifyCode' => 'Verification Code',
        ];
    }

    /**
     * Sends an email to the specified email address using the information collected by this model.
     * @param string $email the target email address
     * @return bool whether the model passes validation
     */
    public function contact($email)
    {
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo($email)
                ->setFrom([$this->email => $this->name])
                ->setSubject($this->subject)
                ->setTextBody($this->body)
                ->send();

            return true;
        }
        return false;
    }
}

models/LoginForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * LoginForm is the model behind the login form.
 *
 * @property User|null $user This property is read-only.
 *
 */
class LoginForm extends Model
{
    public $username;
    public $password;
    public $rememberMe = true;

    private $_user = false;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // username and password are both required
            [['username', 'password'], 'required'],
            // rememberMe must be a boolean value
            ['rememberMe', 'boolean'],
            // password is validated by validatePassword()
            ['password', 'validatePassword'],
        ];
    }

    /**
     * Validates the password.
     * This method serves as the inline validation for password.
     *
     * @param string $attribute the attribute currently being validated
     * @param array $params the additional name-value pairs given in the rule
     */
    public function validatePassword($attribute, $params)
    {
        if (!$this->hasErrors()) {
            $user = $this->getUser();

            if (!$user || !$user->validatePassword($this->password)) {
                $this->addError($attribute, 'Incorrect username or password.');
            }
        }
    }

    /**
     * Logs in a user using the provided username and password.
     * @return bool whether the user is logged in successfully
     */
    public function login()
    {
        if ($this->validate()) {
            return Yii::$app->user->login($this->getUser(), $this->rememberMe ? 3600*24*30 : 0);
        }
        return false;
    }

    /**
     * Finds user by [[username]]
     *
     * @return User|null
     */
    public function getUser()
    {
        if ($this->_user === false) {
            $this->_user = User::findByUsername($this->username);
        }

        return $this->_user;
    }
}

models/User.php
<?php

namespace app\models;

class User extends \yii\base\BaseObject implements \yii\web\IdentityInterface
{
    public $id;
    public $username;
    public $password;
    public $authKey;
    public $accessToken;

    private static $users = [
        '100' => [
            'id' => '100',
            'username' => 'admin',
            'password' => 'admin',
            'authKey' => 'test100key',
            'accessToken' => '100-token',
        ],
        '101' => [
            'id' => '101',
            'username' => 'demo',
            'password' => 'demo',
            'authKey' => 'test101key',
            'accessToken' => '101-token',
        ],
    ];


    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return isset(self::$users[$id]) ? new static(self::$users[$id]) : null;
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        foreach (self::$users as $user) {
            if ($user['accessToken'] === $token) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        foreach (self::$users as $user) {
            if (strcasecmp($user['username'], $username) === 0) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->authKey;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->authKey === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return $this->password === $password;
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    public function actionIndex()
    {
        return $this->render('index');
    }
    public function actionEstamos()
    {
        return $this->render('dondeestamos');
    }
    public function actionConocenos()
    {
        return $this->render('conocenos');
    }
     public function actionContacto()
    {
         //var_dump(Yii::$app->request->get('nombre'));
         //var_dump($_REQUEST);
         $datos=Yii::$app->request->get();
         $vista="contacto";
         $longitud=0;
         
         /**
          * conocer si he pulsado el botón enviar y por lo tanto 
          * me llegan datos
          */
    if(isset($datos['boton'])){
            $longitud= strlen($datos['nombre']);
            $vista="resultado";
                 
         }
         return $this->render($vista,[
             "titulo"=>"Introduce tus datos",
             "longitud"=>$longitud,
             ]);
    }
    

   

}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\widgets\Alert;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar; 
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
<?php
NavBar::begin([
    'brandLabel' => FALSE,
    'options' => ['class' => 'navbar navbar-inverse'],
    ]);
echo Nav::widget([
    'items' => [
        ['label' => 'Home', 'url' => ['/site/index']],
        ['label' => 'Dónde Estamos', 'url' => ['/site/estamos']],
        ['label' => 'Conócenos', 'url' => ['/site/conocenos']],
        ['label' => 'Contacto', 'url' => ['/site/contacto']],
    ],
    'options' => ['class' => 'navbar-nav'],
]);
NavBar::end();
?>

    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</div>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/conocenos.php
<?php
use yii\helpers\Html;

?>

    
    <div class="row">
  <div class="col-sm-6 col-md-4">
    <div class="thumbnail">
        <?= Html::img('@web/imgs/1.jpg', ['alt' => 'My logo']) ?>
      
      <div class="caption">
        <h3>Foto 1</h3>
        
      </div>
    </div>
  </div>
         <div class="col-sm-6 col-md-4">
    <div class="thumbnail">
       <?= Html::img('@web/imgs/2.jpg', ['alt' => 'My logo']) ?>
      
      <div class="caption">
        <h3>Foto 2</h3>
        
      </div>
    </div>
  </div>
         <div class="col-sm-6 col-md-4">
    <div class="thumbnail">
       <?= Html::img('@web/imgs/3.jpg', ['alt' => 'My logo']) ?>
      
      <div class="caption">
        <h3>Foto 3</h3>
        
      </div>
    </div>
  </div>
        
</div>

views/site/contacto.php
<h2><?= $titulo; ?></h2>
<?php 
//echo '<pre>';
//var_dump($this);
//\yii\helpers\VarDumper::dump($this,2);
//echo '</pre>';
?>

<form method="get">
   <div> <label for="nombre">Nombre completo</label><input type="text" name="nombre" id="nombre"> <button name="boton">Enviar</button><div>
          
</form>
<?php

views/site/dondeestamos.php
<iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2895.951851936285!2d-3.8139163845084374!3d43.46160237912838!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0xd494bcc568fd8c3%3A0x7858c552ade0effc!2sAlpe+Formacion!5e0!3m2!1ses!2ses!4v1536574383209" width="600" height="450" frameborder="0" style="border:0" allowfullscreen></iframe>

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'primer ejemplo de Yii';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>¡Felicidades!</h1>

        <p class="lead">Desarrollado Cristina Galán.</p>

        
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-lg-4">
                <h2>API de Yii</h2>

                <p>Todas las clases de Yii.</p>

                <p><a class="btn btn-default" href="https://www.yiiframework.com/doc/api/2.0">API Yii 2</a></p>
            </div>
            <div class="col-lg-4">
                <h2>Manual Yii 2</h2>

                <p>Manual de Clases de  Yii2.</p>
               <p> <?= Html::a('Guía de Yii', 'https://www.yiiframework.com/doc/guide/2.0/es',['class' => 'btn btn-default']) ?></p>
               
            </div>
            
        </div>

    </div>
</div>

views/site/resultado.php
<?php
echo $longitud;